<template>
  <div>
    <!--引用表格-->
    <BasicTable @register="registerTable" :rowSelection="rowSelection">
      <!-- 行业分类 -->
      <template #form-suspect="{ model, field }">
        <a-select v-model:value="model[field]" placeholder="请选择行业分类" :fieldNames="{ label: 'text', value: 'value' }"
          :options="isSuspectOptions" @change="changeSuspect"></a-select>
      </template>
      <template #form-category="{ model, field }">
        <a-tree-select v-model:value="model[field]" show-search placeholder="请选择二级" allow-clear tree-default-expand-all
          :field-names="{ label: 'name', value: 'id', children: 'children' }" :tree-data="treeData"
          tree-node-filter-prop="label">
          <template #suffixIcon>
            <SmileOutlined />
          </template>
        </a-tree-select>
      </template>
      <!--插槽:table标题-->
      <template #tableTitle>
        <a-button type="primary" @click="move" v-auth="'qdml-gzml-ycygz'">移出预关注</a-button>
        <a-button type="primary" @click="handleView" v-auth="'qdml-gzml-ckxx'">查看基本信息</a-button>
      </template>
      <!--操作栏-->
      <template #action="{ record }">
        <TableAction :actions="getTableAction(record)" />
      </template>
    </BasicTable>
  </div>
  <MoveinModal @register="registerMoveModal" @success="handleSuccess" />
  <a-modal v-model:visible="open" :centered="true" title="信息">
      <template #footer>
        <a-button key="submit" type="primary" @click="open = false">确定</a-button>
      </template>
      <div class="py-10 ml-6">该地块还未进行填报，没有详情可以查看</div>
    </a-modal>
</template>

<script lang="ts" name="directory-gzml-gzml" setup>
import { ref, computed, unref } from 'vue';
import { BasicTable, useTable, TableAction } from '/@/components/Table';
import { useModal } from '/@/components/Modal';
import { useListPage } from '/@/hooks/system/useListPage';
import { columns, searchFormSchema, useSuspectsData, useCategoryData } from './data';
import { BahygzList, deleteOne, batchDelete, getImportUrl, getExportUrl } from './api';
import MoveinModal from '../components/MoveinModal.vue'
import { useMessage } from '/@/hooks/web/useMessage';
import { useRouter } from 'vue-router';
const { createMessage } = useMessage();
//注册model
const [registerModal, { openModal }] = useModal();
const [registerMoveModal, { openModal: openMoveModal }] = useModal();
//注册table数据
const { prefixCls, tableContext, onExportXls, onImportXls } = useListPage({
  tableProps: {
    title: '清单名录-预关注地块清单',
    api: BahygzList,
    columns,
    canResize: false,
    clickToRowSelect: true,
    //定义rowSelection的类型，默认是checkbox多选，可以设置成radio单选 
    rowKey: "wrdkid",
    rowSelection: { type: 'radio' },
    formConfig: {
      labelWidth: 120,
      schemas: searchFormSchema,
      autoSubmitOnEnter: true,
      showAdvancedButton: false,
    },
    showIndexColumn: true,
    actionColumn: {
      width: 120,
    },
  },
  exportConfig: {
    name: '清单名录-预关注地块清单',
    url: getExportUrl,
  },
  importConfig: {
    url: getImportUrl,
  },
});
const open = ref(false)
const isSuspectOptions = useSuspectsData().data; // 行业分类
const useCategory = useCategoryData();
const treeData = useCategory.data; // 行业类别-数据
const changeSuspect = useCategory.changeIsSuspect; // 行业类别-方法
const [registerTable, { reload }, { rowSelection,selectedRows, selectedRowKeys }] = tableContext;

/**
 * 新增事件
 */
function handleAdd() {
  openModal(true, {
    isUpdate: false,
    showFooter: true,
  });
}
/**
 * 编辑事件
 */
function handleEdit(record: Recordable) {
  openModal(true, {
    record,
    isUpdate: true,
    showFooter: true,
  });
}
// 移入关注
function move() {
    if (selectedRowKeys.value.length == 0) {
        createMessage.info('请选择要移入关注的数据');
        return
    }
    openMoveModal(true, {
        record: {
          ...selectedRows.value[0],
          type:'mouse'
        },
        isUpdate: true,
        showFooter: true,
    });
}
/**
 * 详情
 */
function handleDetail(record: Recordable) {
  openModal(true, {
    record,
    isUpdate: true,
    showFooter: false,
  });
}
/**
 * 删除事件
 */
async function handleDelete(record) {
  await deleteOne({ id: record.id }, reload);
}
let router = useRouter();
function handleView() {
  if (selectedRowKeys.value.length == 0) {
    createMessage.info('请选择需要处理的内容，每次只能选中一条');
    return
  }
  const record: any = selectedRows.value[0]
  if (!record.dclx) {
    open.value = true
    return
  }
  // router.push(`/directory/mlzk/land/modules/ViewModal?wrdkid=${record.wrdkid}`)
  router.push(`/dkgl/investigate/modal/lookDataFilling?wrdkid=${selectedRowKeys.value[0]}`)
}
/**
 * 批量删除事件
 */
async function batchHandleDelete() {
  await batchDelete({ ids: selectedRowKeys.value }, reload);
}
/**
 * 成功回调
 */
 function handleSuccess() {
    selectedRows.value = []
    selectedRowKeys.value = []
    reload();
}
/**
 * 操作栏
 */
function getTableAction(record) {
  return [
    {
      label: '详情',
      onClick: handleEdit.bind(null, record),
    },
  ];
}
  /**
 * 下拉操作栏
 */
  // function getDropDownAction(record) {
  //   return [
  //     {
  //       label: '详情',
  //       onClick: handleDetail.bind(null, record),
  //     },
  //     {
  //       label: '删除',
  //       popConfirm: {
  //         title: '是否确认删除',
  //         confirm: handleDelete.bind(null, record),
  //       },
  //     },
  //   ];
  // }
</script>
<style scoped></style>
